﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Public Class FrmStudents

    Private Sub DgStudents_CellContentClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DgStudents.CellContentClick

        If e.ColumnIndex = 3 Then
            If DgStudents.IsCurrentRowDirty Then
                ' إنهاء التحرير لقبول التلميذ الحالي إن كان ما زال في وضع التحرير
                DgStudents.EndEdit()
                ' إنهاء التحرير بمفرده لا ينقل التغييرات إلى مجموعة البيانات
                ' ولإجبار جدول البيانات على فعل هذا، سنطلب من النموذج فحص بياناته
                Me.Validate()
            End If

            ShowGrades(DgStudents.CurrentRow.Index)

            FrmGrades.ShowDialog()
        End If
    End Sub

    Sub ShowGrades(ByVal RowIdx As Integer)
        Dim StdRel = DsStudents.Students.ChildRelations(0).RelationName
        Dim RowView = DsStudents.Students.DefaultView(RowIdx)
        Dim Grades = RowView.CreateChildView(StdRel)
        Grades.Sort = "SubjectID"
        Dim SubjRows = DsStudents.Subjects.Rows
        For i = 0 To SubjRows.Count - 1
            Dim SbjID = SubjRows(i)("ID")
            If Grades.Find(SbjID) = -1 Then
                Dim Rv = Grades.AddNew()
                Rv("SubjectID") = SbjID
                Rv.EndEdit()
            End If
        Next

        FrmGrades.DgGrades.DataSource = Grades
        Dim GradesCols = FrmGrades.DgGrades.Columns
        GradesCols(0).Visible = False
        GradesCols(1).Visible = False
        GradesCols(2).HeaderText = "المادة"
        GradesCols(2).DisplayIndex = 0
        GradesCols(3).HeaderText = "الدرجة"

        FrmGrades.Text = "درجات الطالب " & DgStudents.CurrentRow.Cells(1).Value
        FrmGrades.ShowSum()
    End Sub

    Private Sub DgStudents_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles DgStudents.DataError
        Beep()
        e.Cancel = True
    End Sub

    Private Sub BtSubjects_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSubjects.Click
        FrmSubjects.DgSubjects.DataSource = Me.DsStudents
        FrmSubjects.ShowDialog()
    End Sub

    Private Sub BtSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSave.Click
        If SvFile.ShowDialog = Windows.Forms.DialogResult.OK Then
            ' نسخ مجموعة البيانات إلى مجموعة بيانات احتياطية
            Dim Ds As MyDataSet = DsStudents.Copy
            ' حذف عمود المواد من مجموعة البيانات الاحتياطية،
            ' لأنه عمود محسوب، وحفظه في الملف يزيد حجمه بلا ضرورة
            Ds.Grades.Columns.Remove("Subject")
            ' لا نحتاج إلى حفظ المخطط، لانه محفوظ بالفعل في ملف المنخطط
            Ds.WriteXml(SvFile.FileName)
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If DsStudents.HasChanges Then
            Select Case MsgBox("هل تريد حفظ التغييرات قبل تحميل بيانات جديدة؟", MsgBoxStyle.YesNoCancel)
                Case MsgBoxResult.Yes
                    BtSave.PerformClick()
                Case MsgBoxResult.Cancel
                    Exit Sub
            End Select
        End If

        If OpnFile.ShowDialog = Windows.Forms.DialogResult.OK Then
            DsStudents.Clear()
            DsStudents.ReadXml(OpnFile.FileName)
            DsStudents.AcceptChanges()

            ShowSum()

        End If
    End Sub

    Sub ShowSum()
        For I = 0 To DgStudents.Rows.Count - 1
            Dim SumCell = DgStudents("SumCol", I)
            If SumCell.Value Is Nothing Then
                Dim StdId = DgStudents("IDCol", I).Value
                If StdId Is Nothing Then Exit Sub
                SumCell.Value = DsStudents.Grades.Compute("SUM(Grade)", "StudentID = " & Trim(StdId))
            End If
        Next
    End Sub

    Private Sub FrmStudents_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If DsStudents.HasChanges Then
            Select Case MsgBox("هل تريد حفظ التغييرات قبل إغلاق البرنامج؟", MsgBoxStyle.YesNoCancel)
                Case MsgBoxResult.Yes
                    BtSave.PerformClick()
                Case MsgBoxResult.Cancel
                    e.Cancel = True
            End Select
        End If
    End Sub

    Private Sub BtSave2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSave2.Click
        If SvFile.ShowDialog = Windows.Forms.DialogResult.OK Then
            ' الاحتفاظ بمرجع للعمود قبل حذفه
            Dim Col = DsStudents.Grades.SubjectColumn
            ' حذف عمود المواد من مجموعة البيانات
            DsStudents.Grades.Columns.Remove("Subject")
            ' لا نحتاج إلى حفظ المخطط، لانه محفوظ بالفعل في ملف المنخطط
            DsStudents.WriteXml(SvFile.FileName)
            DsStudents.Grades.Columns.Add(Col)
            Col.SetOrdinal(2)

        End If
    End Sub

    Sub ShowStudentSum(ByVal StdId As Integer)
        Dim Row = DsStudents.Students.Rows.Find(StdId)
        Dim Indx = DsStudents.Students.Rows.IndexOf(Row)
    End Sub

    Private Sub DgStudents_Sorted(ByVal sender As Object, ByVal e As System.EventArgs) Handles DgStudents.Sorted
        ShowSum()
    End Sub
End Class
