﻿Public Class TreeCombo
    Inherits ComboBox

    Private treeViewHost As ToolStripControlHost
    Private Shadows dropDown As ToolStripDropDown

    Public Sub New()

        Dim treeView As New TreeView()
        treeView.HideSelection = False
        treeView.BorderStyle = BorderStyle.None
        treeViewHost = New ToolStripControlHost(treeView)
        dropDown = New ToolStripDropDown()
        dropDown.Items.Add(treeViewHost)
        AddHandler treeView.AfterSelect, AddressOf TV_AfterSelect
    End Sub

    Private Sub TV_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs)
        Me.Text = e.Node.Text
    End Sub

    Public ReadOnly Property MyTreeView() As TreeView
        Get
            Return treeViewHost.Control '
        End Get
    End Property

    Private Sub ShowDropDown()
        If Not (dropDown Is Nothing) Then
            MyTreeView.Width = Me.DropDownWidth
            MyTreeView.Height = DropDownHeight
            Try
                MyTreeView.SelectedNode = MyTreeView.Nodes.Find(Me.Text, True)(0)
            Catch
                MyTreeView.SelectedNode = Nothing
            End Try
            dropDown.Show(Me, Me.DropDownWidth, Me.Height)

        End If
    End Sub

    Private Const WM_USER As Integer = &H400
    Private Const WM_REFLECT As Integer = WM_USER + &H1C00
    Private Const WM_COMMAND As Integer = &H111
    Private Const CBN_DROPDOWN As Integer = 7

    Public Shared Function HIWORD(ByVal n As Integer) As Integer
        Return (n >> 16) And &HFFFF
    End Function

    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = WM_REFLECT + WM_COMMAND Then
            If HIWORD(CType(m.WParam, Integer)) = CBN_DROPDOWN Then
                ShowDropDown()
                Return
            End If
        End If
        MyBase.WndProc(m)
    End Sub

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (dropDown Is Nothing) Then
                dropDown.Dispose()
                dropDown = Nothing
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
End Class

