﻿
Public Class TreeComboColumn
    Inherits DataGridViewColumn

    Public Sub New()
        MyBase.New(New TreeComboCell())
    End Sub

    Public Overrides Property CellTemplate() As DataGridViewCell
        Get
            Return MyBase.CellTemplate
        End Get

        Set(ByVal value As DataGridViewCell)
            ' Ensure that the cell used for the template is a TreeCell.
            If (value IsNot Nothing) AndAlso value.GetType() IsNot GetType(TreeComboCell) Then
                Throw New InvalidCastException("Must be a TreeComboCell")
            End If
            MyBase.CellTemplate = value

        End Set
    End Property


End Class


