﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.SqlClient

Public Class Form1

    Dim Ds As New DataSet
    Dim DsErr As New DataSet

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' إضافة شرط إلى نهاية استعلام التحديث
        'سيحدث خطأ لو كان هناك استعلام تحديد في نهاية استعلام التحديث 
        DaAuthors.UpdateCommand.CommandText &=
                " And About = @Original_About"
        Dim P As New SqlParameter("@Original_About", SqlDbType.NVarChar, -1, ParameterDirection.Input, False, 0, 0, "About", DataRowVersion.Original, Nothing)
        DaAuthors.UpdateCommand.Parameters.Add(P)

        DaAuthors.FillSchema(Ds, SchemaType.Mapped)
        DaAuthors.Fill(Ds, "Authors")
        DgAuthors.DataSource = Ds.Tables("Authors")
        DgAuthors.Columns("RowVersion").Visible = False
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' إذا كانت هناك سجلات خطأ
        If DsErr.Tables.Count > 0 Then
            ' إزالة سجلات الخطأ الخاصة بالسجلات التي سنعيد محاولة حفظها
            For Each R As DataRow In DsErr.Tables(0).Rows
                If R.RowState = DataRowState.Modified Then R.Delete()
            Next
            DsErr.AcceptChanges()
        End If

        ' تحديث قاعدة البيانات
        DaAuthors.Update(Ds)
    End Sub

    Private Sub DaAuthors_RowUpdated(ByVal sender As Object, ByVal e As System.Data.SqlClient.SqlRowUpdatedEventArgs) Handles DaAuthors.RowUpdated
        If e.RecordsAffected = 0 Then
            e.Status = UpdateStatus.SkipCurrentRow
            DaErrAuthor.SelectCommand.Parameters(0).Value = e.Row("ID")
            DaErrAuthor.FillSchema(DsErr, SchemaType.Mapped)
            If DaErrAuthor.Fill(DsErr, "Authors") > 0 Then
                e.Row.RowError = "حدث تعارض مع السجل الأصلي لأن أحد المستخدمين قام بتعديله"
            Else
                e.Row.RowError = "هذا السجل حذفه مستخدم آخر من قاعدة البيانات"
            End If
            DgErrors.DataSource = DsErr.Tables(0)
            DgErrors.Columns("RowVersion").Visible = False
        End If

    End Sub

    Private Sub DgAuthors_RowHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DgAuthors.RowHeaderMouseClick
        Dim R = DgAuthors.Rows(e.RowIndex)
        Dim Pos = DgAuthors.GetRowDisplayRectangle(e.RowIndex, False).Location
        If R.ErrorText.Contains("حذفه") Then
            InsertCntxt.Show(DgAuthors, Pos + e.Location)
        ElseIf R.ErrorText.Contains("بتعديله") Then
            UpdateCntxt.Show(DgAuthors, Pos + e.Location)
        End If
    End Sub

    Private Sub mnuSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSave.Click
        Dim DgRow = DgAuthors.CurrentRow
        Dim ID = DgRow.Cells("ID").Value
        ' الحصول على كائن الصف بدلاله مفتاحه الأساسي
        Dim DsErrRow = DsErr.Tables("Authors").Rows.Find(ID)
        ' دمج القيمة الأصلية للسجل المعدل، بالقيمة الحالية للسجل الذي يريد المستخدم حفظه
        Ds.Merge({DsErrRow}, True, MissingSchemaAction.Ignore)
        Dim DsRow = Ds.Tables("Authors").Rows.Find(ID)
        ' إزالة الأخطاء لإخفاء أيقونة الخطأ
        DsRow.ClearErrors()
        ' سنعتبر سجل الخطأ معدلا، حتى يمكننا حذفه عند ضغط زر الحفظ
        DsErrRow.SetModified()
    End Sub


    Private Sub mnuInsertRec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuInsertRec.Click
        Dim DgRow = DgAuthors.CurrentRow
        Dim ID = DgRow.Cells("ID").Value
        Dim DsRow = Ds.Tables(0).Rows.Find(ID)
        ' يجب قبول التغييرات أولا قبل اعتبار السجل جديدا، لجعل النسخة الحالية هي نفسها النسخة الأصلية
        DsRow.AcceptChanges()
        DsRow.SetAdded()
        ' إزالة الأخطاء لإخفاء أيقونة الخطأ
        DsRow.ClearErrors()
    End Sub

    Private Sub mnuCancelChanges_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCancelChanges.Click
        Dim DgRow = DgAuthors.CurrentRow
        Dim ID = DgRow.Cells("ID").Value
        ' الحصول على كائن الصف بدلاله مفتاحه الأساسي
        Dim DsErrRow = DsErr.Tables("Authors").Rows.Find(ID)
        ' دمج السجل المعدل، بالسجل الذي يريد المستخدم إلغاءه
        Ds.Merge({DsErrRow}, False, MissingSchemaAction.Ignore)
        ' إزالة سجل الخطأ
        DsErrRow.Delete()

    End Sub

    Private Sub mnuDelRec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuDelRec.Click
        Dim DgRow = DgAuthors.CurrentRow
        Dim ID = DgRow.Cells("ID").Value
        Dim DsRow = Ds.Tables(0).Rows.Find(ID)
        ' حذف السجل من مجموعة البيانات
        DsRow.Delete()
        ' قبول التغييرات، حتى لا يحاول موصل البيانات حذف السجل المناظر من قاعدة البيانات
        ' صحيح أنه لن يجده، ولكنه تضيع وقت لا طاائل منه
        DsRow.AcceptChanges()

    End Sub

End Class
