﻿' هذا المثال كتبه م. محمد حمدي غانم، وهو أحد أمثلة كتاب 
' من الصفر إلى الاحتراف: برمجة نماذج الويندوز في سي شارب 2010
' الناشر: مكتبة دار المعرفة، 4 شارع السرايات
' أمام هندسة عين شمس ـ بالقرب من ميدان عبده باشا ـ العباسية ـ القاهرة، 
' هاتف 26844043 
' بريد إلكتروني: dar_elmaarefa@yahoo.com

Imports System.Data.SqlClient
Public Class Form1

    Dim Ds As New DataSet
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' تحميل مخطط جدول المؤلفين دون بياناته.
        ' هذا يتيح للمستخدم إضافة سجلات جديدة دون العبث بالسجلات القديمة
        DaAuthors.FillSchema(Ds, SchemaType.Mapped)
        DaCountries.Fill(Ds)        
        DataGridView1.DataSource = Ds
        DataGridView1.DataMember = "Authors"
        ' حذف عمود ارقام الدول
        DataGridView1.Columns.Remove("CountryID")
        ' تعريف عمود قوائم منسدلة
        Dim Col As New DataGridViewComboBoxColumn()
        Col.Name = "Country"
        ' ملء العمود بأسماء الدول
        Col.DataSource = Ds.Tables("Countries")
        Col.DisplayMember = "Name"
        ' ربط العمود بحقل رقم الدولة في جدول المؤلفين
        Col.DataPropertyName = "CountryID"
        Col.ValueMember = "ID"
        ' إضافة العمود إلى جدول العرض
        DataGridView1.Columns.Insert(2, Col)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        TxtReport.Clear()
        If ChkContinue.Checked Then ' استمرار التحديث رغم حدوث أخطاء
            DaAuthors.ContinueUpdateOnError = True
            DaAuthors.Update(Ds)
            If Ds.Tables(0).HasErrors = False Then Return

            ' علينا جمع الأخطاء التي حدثت وعرضها في تقرير للمستخدم
            Dim Report As New System.Text.StringBuilder
            Report.AppendLine("حدثت هذه الأخطاء أثناء محاولة حفظ البيانات:")
            Dim I = 0
            For Each R As DataRow In Ds.Tables(0).Rows
                If R.HasErrors Then
                    I += 1
                    Report.AppendLine(Trim(I) & "- " & R.RowError)
                    R.ClearErrors()
                End If
            Next
            TxtReport.Text = Report.ToString

        Else ' إيقاف التحديث عند حدوث أي خطأ
            DaAuthors.ContinueUpdateOnError = False
            Try
                DaAuthors.Update(Ds)
            Catch ex As SqlException
                MsgBox(ex.Message)
            End Try
        End If

    End Sub

    Private Sub DataGridView1_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles DataGridView1.DataError
        ' لإلغاء الانتقال من الصف، والاحتفاظ بالقيم التي أدخلها المستخدم فيه
        e.Cancel = True
        ' عرض رسالة خطأ خاصة بك، بدلا من الرسالة الافتراضية
        MsgBox("بعض القيم التي أدخلتها غير صحيحة")
    End Sub
End Class
